"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fsStat = require("@nodelib/fs.stat");
const fs = require("./adapters/fs");
class Settings {
    constructor(_options = {}) {
        this._options = _options;
        this._followSymbolicLinks = this._setDefaultValue(this._options.followSymbolicLinks, false);
        this._fs = fs.createFileSystemAdapter(this._options.fs);
        this._stats = this._setDefaultValue(this._options.stats, false);
        this._throwErrorOnBrokenSymbolicLink = this._setDefaultValue(this._options.throwErrorOnBrokenSymbolicLink, true);
        this._fsStatSettings = new fsStat.Settings({
            followSymbolicLink: this._followSymbolicLinks,
            fs: this._fs,
            throwErrorOnBrokenSymbolicLink: this._throwErrorOnBrokenSymbolicLink
        });
    }
    get followSymbolicLinks() {
        return this._followSymbolicLinks;
    }
    get fs() {
        return this._fs;
    }
    get stats() {
        return this._stats;
    }
    get throwErrorOnBrokenSymbolicLink() {
        return this._throwErrorOnBrokenSymbolicLink;
    }
    get fsStatSettings() {
        return this._fsStatSettings;
    }
    _setDefaultValue(option, value) {
        return option === undefined ? value : option;
    }
}
exports.default = Settings;
